%macro sasdrugdev_createsddcontainer(sddpath=,type=folder,verbose=INFO);
   %let _sddRC_ = %str(-99);
   %let _sddMsg_ = ;

   data _null_; 
      call symput('howmany', strip(put(countc("&sddpath",'/'),2.)));
   run;

   %let fl =%str(/);

   data _null_;
      attrib path length=$400;
      do i = 1 to &howmany;
         path = strip(path) !! "&fl" !! scanq("&sddpath",i,'/');
         call symput("b_path_" !! strip(put(i,8.)),strip(path));
      end;
   run;

   %let level = 0;

   %do i = &howmany %to 1 %by -1;
      %sasdrugdev_containerexists(sddpath=%str(&&b_path_&i),verbose=NONE);
      %if &_sddRC_ = 1 %then %do;
         %let level = &i;
         %let i = 1;
      %end;
   %end;

   %if &verbose eq NONE %then %do;
      %let _errorVerbose_ = 0;
      %let _infoVerbose_  = 0;
   %end;
   %else %if &verbose eq ERROR %then %do;
      %let _errorVerbose_ = 1;
      %let _infoVerbose_  = 0;
   %end;
   %else %if &verbose eq INFO %then %do;
      %let _errorVerbose_ = 1;
      %let _infoVerbose_  = 1;
   %end;

   %if &level = &howmany %then %do;
      %let _sddRC_ = %str(-4);
      %let _sddMsg_ = Entity already exists at: &sddpath;
      %if %eval(&_errorVerbose_) %then %do;
         data _null_;
            put;
            put "ERRO%STR(R): SAS Drug Development Macro: sasdrugdev_createsddcontainer 3.5";
            put "ERRO%STR(R): SAS Drug Development Macro: * Return Code: &_sddRC_";
            put "ERRO%STR(R): SAS Drug Development Macro: * &_sddMsg_";
            put;
         run;
      %end;
   %end;
   %else %do;
      %do i = %eval(&level+1) %to &howmany;
	    %if &i eq &howmany %then %let _ctype_=&type;
		%else %let _ctype_=folder;
         data _null_;
            attrib returnCode length=8;
            attrib message    length=$200;
            declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/CreateContainerCommand", "%bquote(&&b_path_&i)", "&_ctype_");
            declare javaobj results("com/sas/drugdev/remote/sasmacro/results/DefaultResult");
            cmd.callVoidMethod("execute", results); 
            results.callIntMethod("getReturnCode", returnCode);
            results.callStringMethod("getReturnMessage", message);

            call symputx("_sddRC_", returnCode);
            call symputx("_sddMsg_", message);

            if (returnCode=0) then do;
               %if %eval(&_infoVerbose_) %then %do;
                  put;
                  put "NOTE: SAS Drug Development Macro: sasdrugdev_createsddcontainer 3.5";
                  put "NOTE: SAS Drug Development Macro: * Return Code: " returnCode;
                  put "NOTE: SAS Drug Development Macro: * " message;
                  put;
               %end;
            end;
            else do;
               %if %eval(&_errorVerbose_) %then %do;
                  put;
                  put "ERRO%STR(R): SAS Drug Development Macro: sasdrugdev_createsddcontainer 3.5";
                  put "ERRO%STR(R): SAS Drug Development Macro: * Return Code: " returnCode;
                  put "ERRO%STR(R): SAS Drug Development Macro: * " message;
                  put;
               %end;
            end;
         run;
      %end;
   %end;
%mend sasdrugdev_createsddcontainer;
