%macro sasdrugdev_getgroupmembers(sddgroupname=, dsname=work._gmembers_);
%global _sddRC_ _sddMsg_;
  %let _sddRC_=%str(-1);
  %let _sddMsg_=;

  data &dsname(label="Created by sasdrugdev_getgroupmembers" keep=userid groupname action);
    attrib returnCode length=8;
    attrib message    length=$200;
    attrib rowCount   length=8;
    attrib groupname  length=$200 label="GroupName";
    attrib userid     length=$200 label="UserId";
	attrib  action     length=$20   label="Add/Remove";

    declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GetGroupMembersCommand", "%bquote(&sddgroupname)");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/ListResult");
    cmd.callVoidMethod("execute", results);
    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
    if (returnCode=0) then do;
      results.callIntMethod("getReturnedCount", rowCount);
      do row=0 to rowCount - 1;
        groupname=symget('sddgroupname');
        results.callStringMethod("getValue", row, "String", userid);
	    action=action;  * suppressing warning message about uninitialized variable*;
        output;
      end;
      put "NOTE: SAS Drug Development Macro: sasdrugdev_getgroupmembers 3.5";
      put "NOTE: SAS Drug Development Macro: * Get group members for %bquote(&sddgroupname)";
      if (rowCount=0) then 
         put "NOTE: SAS Drug Development Macro: * No group members were found.";
      put "NOTE: SAS Drug Development Macro: * " rowCount " records written to dataset %bquote(&dsname)";
     end;
     else do;
       put "ERROR: SAS Drug Development Macro: sasdrugdev_getgroupmembers 3.5";
       put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
       put "ERROR: SAS Drug Development Macro: * Tried to get group members for %bquote(&sddgroupname)";
       put "ERROR: SAS Drug Development Macro: * " message;
     end;
     call symputx("_sddRC_", returnCode);
     call symputx("_sddMsg_", message);
  run;
%mend sasdrugdev_getgroupmembers;
