%macro sasdrugdev_getgroups(dsname=work._getgroups_);
  %global _sddRC_ _sddMsg_;
  %let _sddRC_=%str(-1);
  %let _sddMsg_=;
  %let _sddRowCount_=%str(-1);

  data &dsname(label="Created by sasdrugdev_getgroups" keep=groupname description);
    attrib returnCode     length=8;
    attrib message        length=$200;
    attrib rowCount       length=8;

    attrib groupname    length=$200 label="Group Name";
    attrib description    length=$200 label="Group Description";

	declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GetGroupsCommand");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/GetGroupsResult");
    cmd.callVoidMethod("execute", results);
    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
    if (returnCode=0) then do;
      results.callIntMethod("getObjectCount", rowCount);
      do row=0 to rowCount - 1;
		    results.callStringMethod("getName", row, groupname);
		    results.callStringMethod("getDescription", row, description);
	        output;
      end;
      put "NOTE: SAS Drug Development Macro: sasdrugdev_getgroups 3.5";
      put "NOTE: SAS Drug Development Macro: * returned a list of groups";
      if (rowCount=0) then
          put "NOTE: SAS Drug Development Macro: * No groups were found.";
      put "NOTE: SAS Drug Development Macro: * " rowCount " records written to dataset &dsname";
    end;
    else do;
      put "ERROR: SAS Drug Development Macro: sasdrugdev_getgroups 3.5";
      put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
      put "ERROR: SAS Drug Development Macro: * Tried to list the groups.";
      put "ERROR: SAS Drug Development Macro: * " message;
    end;
    call symputx("_sddRC_", returnCode);
    call symputx("_sddMsg_", message);
    call symputx("_sddRowCount_", rowCount);
  run;
  %if &_sddRowCount_ > 0 %then %do;
     proc sort data=&dsname;
       by groupname;
     run;
  %end;
%mend sasdrugdev_getgroups;
