%macro sasdrugdev_getsddvalues(listType=, objType=, dsname=work._sddvalues_);
    %global _sddRC_ _sddMsg_;
    %let _sddRC_=%str(-1);
    %let _sddMsg_=;

	%if (&listType=%str()) %then
	    %let listType=parms;

    data &dsname(label="Created by sasdrugdev_getsddvalues" keep=type value objectType);
        attrib returnCode  length=8 
                message     length=$200 
                rowCount     length=8
				type            length=$200  label="List Type"
                value           length=$200  label="Value"
				objectType   length=$50    label="Object Type"
                returnedList length=$50;
        ;
	   declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GetSDDValuesCommand", "%bquote(&listType)", "%bquote(&objType)");
       declare javaobj results("com/sas/drugdev/remote/sasmacro/results/ListResult");
       cmd.callVoidMethod("execute", results);
       results.callIntMethod("getReturnCode", returnCode);
       results.callStringMethod("getReturnMessage", message);
       results.callIntMethod("getReturnedCount", rowCount);
	   isParmList=0;
	   if ("&listType"="parms") then
	      isParmList=1;
       if (returnCode<0) then do;
	      put "ERROR: SAS Drug Development Macro: sasdrugdev_getsddvalues 3.5";
	      put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
	      put "ERROR: SAS Drug Development Macro: * Tried to list values for %bquote(&listType)";
	      put "ERROR: SAS Drug Development Macro: * " message;
		  put;
		  isParmList=1;
       end;
       
       do row=0 to rowCount - 1;
           results.callStringMethod("getValue", row, "", value);
	       if (isParmList) then
	           type='%sasdrugdev_getsddvalues parm value';
		   else
               type=symget('listType');
		   objectType="&objType";
		   put value;
           output;
       end;

	   if (isParmList) then
		   returnedList='valid listType parameter for this %sasdrugdev_getsddvalues';
	   else
		   returnedList="%bquote(&listType)";
	   put;
       put "NOTE: SAS Drug Development Macro: sasdrugdev_getsddvalues 3.5";
       put "NOTE: SAS Drug Development Macro: * Listing values for " returnedList;
       put "NOTE: SAS Drug Development Macro: * " rowCount " records written to dataset &dsname";
      
       call symputx("_sddRC_", returnCode);
       call symputx("_sddMsg_", message);
  run;
%mend sasdrugdev_getsddvalues;
