%macro sasdrugdev_getuserprops(sdduserid=, dsname=work._userprops_);
    %global _sddRC_ _sddMsg_;
    %let _sddRC_=%str(-1);
    %let _sddMsg_=;

    data &dsname(label="Created by sasdrugdev_getuserprops" keep=userid name value);
        attrib returnCode length=8 
                message    length=$200 
                rowCount   length=8
				userid        length=$200 label="Userid"
				name         length=$200 label="Name"
                value         length=$200 label="Value";
        ;
       declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GetUserPropsCommand", "%bquote(&sdduserid)");
       declare javaobj results("com/sas/drugdev/remote/sasmacro/results/PropertiesResult", "%bquote(user)");
       cmd.callVoidMethod("execute", results);
       results.callIntMethod("getReturnCode", returnCode);
       results.callStringMethod("getReturnMessage", message);
       if (returnCode=0) then do;
           results.callIntMethod("getPropertiesCount", rowCount);
           do row=0 to rowCount - 1;
               userid=symget('sdduserid');
               results.callStringMethod("getPropertyName", row, name);
               results.callStringMethod("getProperty", name, value);
               output;
           end;
           put "NOTE: SAS Drug Development Macro: sasdrugdev_getuserprops 3.5";
           put "NOTE: SAS Drug Development Macro: * Listing properties for %bquote(&sdduserid)";
           if (rowCount=0) then 
                put "NOTE: SAS Drug Development Macro: * No properties were found.";
           put "NOTE: SAS Drug Development Macro: * " rowCount " records written to dataset &dsname";
       end;
       else do;
           put "ERROR: SAS Drug Development Macro: sasdrugdev_getuserprops 3.5";
           put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
           put "ERROR: SAS Drug Development Macro: * Return Message: " message;
           put "ERROR: SAS Drug Development Macro: * Tried to get properties for %bquote(&sdduserid)";
           put "ERROR: SAS Drug Development Macro: * " message;
      end;
      call symputx("_sddRC_", returnCode);
      call symputx("_sddMsg_", message);
  run;
%mend sasdrugdev_getuserprops;
