%macro sasdrugdev_getversions(sddpath=, dsname=work._getversions_);
  %global _sddRC_ _sddMsg_;
  %let _sddRC_=%str(-1);
  %let _sddMsg_=;
  %let _sddRowCount_=%str(-1);

  data &dsname(label="Created by sasdrugdev_getversions" keep=verNum);
    attrib returnCode     length=8;
    attrib message        length=$200;
    attrib rowCount       length=8;
    attrib VerNum		  length=$8 ;
  
    declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GetVersionsCommand", "%bquote(&sddpath)");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/ListResult");
    
    cmd.callVoidMethod("execute", results);
    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
    if (returnCode=0) then do;
      results.callIntMethod("getReturnedCount", rowCount);
      do row=0 to rowCount - 1;
        results.callStringMethod("getValue", row, "version", verNum);
        output;
      end;
      put "NOTE: SAS Drug Development Macro: sasdrugdev_getversions 3.5";
      put "NOTE: SAS Drug Development Macro: * returned a list of versions for %bquote(&sddpath)";
      if (rowCount=0) then
          put "NOTE: SAS Drug Development Macro: * No objects were found.";
      put "NOTE: SAS Drug Development Macro: * " rowCount " records written to dataset &dsname";
    end;
    else do;
      put "ERROR: SAS Drug Development Macro: sasdrugdev_getversions 3.5";
      put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
      put "ERROR: SAS Drug Development Macro: * Tried to list the versions for %bquote(&sddpath)";
      put "ERROR: SAS Drug Development Macro: * " message;
    end;
    call symputx("_sddRC_", returnCode);
    call symputx("_sddMsg_", message);
    call symputx("_sddRowCount_", rowCount);
  run;
%mend sasdrugdev_getversions ;
