%macro sasdrugdev_groupexists(groupname=,verbose=INFO);
   %global _sddRC_ _sddMsg_ _sddgroupexists_;

   %let _sddRC_ = %str(-99);
   %let _sddMsg_ = ;
   %let _sddgroupexists_ = ;

   %if &verbose eq NONE %then %do;
      %let _errorVerbose_ = 0;
      %let _infoVerbose_  = 0;
   %end;
   %else %if &verbose eq ERROR %then %do;
      %let _errorVerbose_ = 1;
      %let _infoVerbose_  = 0;
   %end;
   %else %do;
      %let _errorVerbose_ = 1;
      %let _infoVerbose_  = 1;
   %end;

   data _null_;
      attrib returnCode length=8;
      attrib message    length=$200;
      attrib groupexists length=8;
      declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GroupExistsCommand", "%bquote(&groupname)");
      declare javaobj results("com/sas/drugdev/remote/sasmacro/results/GroupExistsResult");
      cmd.callVoidMethod("execute", results); 
      results.callIntMethod("getReturnCode", returnCode);
      results.callStringMethod("getReturnMessage", message);
      results.callBooleanMethod("getGroupExists", groupexists);
      call symputx("_sddRC_", returnCode);
      call symputx("_sddMsg_", message);
      call symputx("_sddgroupexists_", groupexists);

      if (returnCode=0) then do;
         %if %eval(&_infoVerbose_) %then %do;
            put;
            put "NOTE: SAS Drug Development Macro: sdd_groupexists 3.5";
            put "NOTE: SAS Drug Development Macro: * Return Code: " returnCode;
            put "NOTE: SAS Drug Development Macro: * " message;
            put "NOTE: Group &groupname is a group? " groupexists;
            put;
         %end;
      end;
      else do;
         %if %eval(&_errorVerbose_) %then %do;
            put;
            put "ERRO%STR(R): SAS Drug Development Macro: sdd_groupexists 3.5";
            put "ERRO%STR(R): SAS Drug Development Macro: * Return Code: " returnCode;
            put "ERRO%STR(R): SAS Drug Development Macro: * " message;
            put;
         %end;
      end;
   run;
%mend sasdrugdev_groupexists;
