%macro sasdrugdev_logout();
  %put NOTE: SAS Drug Development Macro: sasdrugdev_logout 3.5;

  data _null_;
    attrib returnCode length=8;
    attrib message    length=$200;
    declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/LogoutCommand");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/DefaultResult");
    cmd.callVoidMethod("execute", results); 
    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
    if (returnCode=0) then do;
      put;
      put "NOTE: SAS Drug Development Macro: * " message;
      put;
      end;
    else do;
      put;
      put "ERROR: SAS Drug Development Macro: * Unable to close connection.";
      put "ERROR: SAS Drug Development Macro: * " message;
      put;
      end;
  run;

  /* delete only the _sdd macros that login created. */
  /* other ones may be created by SDD when running in the PE. */
  /* also, deleting mac vars when running the PE can cause problems.  */
	%let loginMacVars=%str(_SDDRC_ _SDDMSG_ _sddJavaLog_   _sddDebugLevel_ _sddRunningInPE_);
    %put NOTE: The SAS Drug Development Macros &_sddRunningInPE_ running in the SAS Drug Development Process Editor;
	%if (%str(%upcase(&_sddRunningInPE_)) ne %str(ARE)) %then %do;
    		%put NOTE: The SAS Drug Development Macros: deleting global macro variables &loginMacVars;
			%let macName=_null_;
			%let mvarcnt=1;
			 %do %until (&macName=%str());
			      %let macName=%scan(&loginMacVars, &mvarcnt);
				  %if (&macName ne %str()) %then %do;
	                   %if (%symexist(&macName) and %symglobl(&macName))  %then
	                        %symdel &macName  /nowarn;
				  %end;
				  %let mvarcnt=%eval(&mvarcnt+1);
			%end;
	%end;
	%else
		%put NOTE: The SAS Drug Development Macros: global macro variable cleanup will not execute.;


%mend sasdrugdev_logout;
