%macro sasdrugdev_sdd_addremove(objID=, cmdClass=, varName=, dsname=, callingMacro=); 

		%global _sddRC_ _sddMsg_;
		%let _sddRC_=%str(-1);
		%let _sddMsg_=;

		%let tempds=_tempAddRemoveDs_;;

		proc sort data=&dsname out=&tempds;
			by &objID &varName;
		run;

* TODO: Catch the bad dataset before it is processes *;

  data _null_;
    attrib returnCode length=8;
    attrib message    length=$200;
    retain errorsFound 0 firstErrorCode firstErrorMessage;

    set &tempds end=eof;
	by &objID &varName;

	if (first.&objID) then do;
          declare javaobj results("com/sas/drugdev/remote/sasmacro/results/ListResult");
		  invalidActionCnt=0;
		  if not(last.&varName) then
		     put "WARNING: duplicate record found for " &objID &varName;
	end;

	if (upcase(action)="ADD") then do;
          results.callVoidMethod("setAddValue", trim(left(&varName)));
	end;
	else if (upcase(action)="REMOVE") then do;
          results.callVoidMethod("setRemoveValue", trim(left(&varName)));
	end;
	else do;
	    put "ERROR: Invalid value for action: " action ". Record will not be processed for " &objID ", &varname "  &varname;
		invalidActionCnt+1;
	end;

	if (last.&objID) then do;
         declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/&cmdClass", trim(left(&objID)));
         cmd.callVoidMethod("execute", results);
         results.callIntMethod("getReturnCode", returnCode);
         results.callStringMethod("getReturnMessage", message);
         if (returnCode=0) then do;
             put;
             put "NOTE: SAS Drug Development Macro: &callingMacro 3.5";
             put "NOTE: SAS Drug Development Macro: * Set &varname for " &objID;
         end;
        else do;
		     errorsFound+1;
             put "ERROR: SAS Drug Development Macro: &callingMacro 3.5";
             put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
             put "ERROR: SAS Drug Development Macro: * Tried to set &varname for " &objID;
             put "ERROR: SAS Drug Development Macro: * " message;
			 if (errorsFound=1) then do;
			      firstErrorCode=returnCode;
				  firstErrorMessage=message;
			 end;
        end;
	end;   ** end last.objID **;

	if (eof) then do;
		** if there were errors, return first error caught  **;
        **otherwise, assume final return code = ok **;
        if (errorsFound>0) then do;
           call symputx("_sddRC_",   firstErrorCode);
           call symputx("_sddMsg_", firstErrorMessage);
	    end;
		else do;
           call symputx("_sddRC_", returnCode);
           call symputx("_sddMsg_", message);
		end;
	end;   ** end eof **;

run;

	%if (%sysfunc(exist(&tempds))>0) %then %do;
	    proc datasets library=work nolist;
	         delete &tempds;
	    quit;;; run;;;
	%end;


%mend sasdrugdev_sdd_addremove;
