%macro sasdrugdev_sdd_getproperty(propname=, callingMacro=, cmdClass=);
  %global _sddRC_ _sddMsg_ _sddPropname_ _sddPropvalue_;
  %let _sddRC_=%str(-1);
  %let _sddMsg_=;
  %let _sddPropname_=;
  %let _sddPropvalue_=;

  data _null_;
    attrib returnCode length=8;
    attrib message    length=$200;
	attrib name length=$200;
	attrib value length=$200;
	declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/&cmdClass");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/PropertyResult", "%bquote(&propname)");
    cmd.callVoidMethod("execute", results); 
    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
	results.callStringMethod("getName", name);
	results.callStringMethod("getValue", value);
    if (returnCode=0) then do;
      put;
      put "NOTE: SAS Drug Development Macro: &callingMacro 3.5";
      put "NOTE: SAS Drug Development Macro: * Return Code: " returnCode;
      put "NOTE: SAS Drug Development Macro: * " message;
      put;
    end;
    else do;
      put;
      put "ERROR: SAS Drug Development Macro:  &callingMacro 3.5";
      put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
      put "ERROR: SAS Drug Development Macro: * " message;
      put;
    end;
    call symputx("_sddRC_", returnCode);
    call symputx("_sddMsg_", message);
    call symputx("_sddPropname_", name);
    call symputx("_sddPropvalue_", value);
  run;
%mend sasdrugdev_sdd_getproperty;
