%macro sasdrugdev_setcontainerowner(sddpath=, sdduserid=, recursiveLevel=); 
   %global _sddRC_ _sddMsg_;
   %let _sddRC_=%str(-1);
   %let _sddMsg_=;

   data _null_;
      attrib returnCode length=8;
      attrib message    length=$200;
      declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/SetContainerOwnerCommand","%bquote(&sddpath)", "%bquote(&sdduserid)", "%bquote(&recursiveLevel)");
      declare javaobj results("com/sas/drugdev/remote/sasmacro/results/DefaultResult");
      cmd.callVoidMethod("execute", results);
      results.callIntMethod("getReturnCode", returnCode);
      results.callStringMethod("getReturnMessage", message);
      put;
      put "NOTE: SAS Drug Development Macro: sasdrugdev_setcontainerowner 3.5";
      if (returnCode=0) then do;
           put "NOTE: SAS Drug Development Macro: * Set owner for %bquote(&sddpath):  owner= &sdduserid";
    end; 
    else do;
          put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
          put "ERROR: SAS Drug Development Macro: * Tried to set owner for %bquote(&sddpath)";
          put "ERROR: SAS Drug Development Macro: * " message;
    end;
    call symputx("_sddRC_", put(returnCode, best.));
    call symputx("_sddMsg_", message);
  run;
%mend sasdrugdev_setcontainerowner ;
