%macro sasdrugdev_setcontainerperms(dsname=work._containerperms_, recurse=NONE, keepGroup=_NONE_,verbose=INFO);
   %let thisMac=&sysmacroname;
   
   %if %quote(&recurse)=%quote(ALL) %then %do;
      proc sql noprint;
         select distinct fullpathname into :_rootPath_ 
         from &dsname;
      quit;

      %sasdrugdev_getobjects( sddpath   = %trim(&_rootPath_)
                            , recursive = true
                            , typeDef   = %STR(folder)
                            , dsname    = work._permissions_recurse_
                            );

      proc sort data = _permissions_recurse_ (keep=fullpathname iscontainer where=(iscontainer=1)) 
                out  = _recurse_ (drop = iscontainer)
                nodupkeys;
         by fullpathname;
      run;

      proc sql noprint;
         create table _perms_ as 
         select a.fullpathname,b.*
         from _recurse_ as a,&dsname(drop=fullpathname) as b;
      quit;


      %sasdrugdev_sdd_setperms( objID        = fullPathName
                       , cmdClass     = SetContainerPermissionsCommand
                       , dsname       = _perms_
                       , callingMacro = %lowcase(&thisMac)
                       , recurse      = NONE
					   , keepGroup    = &keepGroup
                       , verbose      = &verbose
                       );
   %end;
   %else %do;
      %sasdrugdev_sdd_setperms( objID        = fullPathName
                       , cmdClass     = SetContainerPermissionsCommand
                       , dsname       = &dsname
                       , callingMacro = %lowcase(&thisMac)
                       , recurse      = &recurse
   					   , keepGroup    = &keepGroup
                       , verbose      = &verbose
                       );
   %end;
%mend sasdrugdev_setcontainerperms;
