%macro sasdrugdev_setuserauth(sdduserid=, provider=, id=); 
   %global _sddRC_ _sddMsg_;
   %let _sddRC_=%str(-1);
   %let _sddMsg_=;

   data _null_;
      attrib returnCode length=8;
      attrib message    length=$200;
      declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/SetUserAuthenticationCommand","%bquote(&sdduserid)", "%bquote(&provider)", "%bquote(&id)");
      declare javaobj results("com/sas/drugdev/remote/sasmacro/results/PropertiesResult", "user");
      cmd.callVoidMethod("execute", results);
      results.callIntMethod("getReturnCode", returnCode);
      results.callStringMethod("getReturnMessage", message);
      put;
      put "NOTE: SAS Drug Development Macro: sasdrugdev_setuserauth 3.5";
      if (returnCode=0) then do;
           put "NOTE: SAS Drug Development Macro: * Set authentication for %bquote(&sdduserid):  &provider  ,&id ";
    end; 
    else do;
          put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
          put "ERROR: SAS Drug Development Macro: * Tried to set authentication for %bquote(&sdduserid)";
          put "ERROR: SAS Drug Development Macro: * " message;
    end;
    call symputx("_sddRC_", put(returnCode, best.));
    call symputx("_sddMsg_", message);
  run;
%mend sasdrugdev_setuserauth;
