%macro sasdrugdev_updateuser(sdduserid=, sddpassword=,verbose=INFO);
%global _sddRC_ _sddMsg_;
  %let _sddRC_=%str(-99);
  %let _sddMsg_=;

   %if &verbose eq NONE %then %do;
      %let _errorVerbose_ = 0;
      %let _infoVerbose_  = 0;
   %end;
   %else %if &verbose eq ERROR %then %do;
      %let _errorVerbose_ = 1;
      %let _infoVerbose_  = 0;
   %end;
   %else %if &verbose eq INFO %then %do;
      %let _errorVerbose_ = 1;
      %let _infoVerbose_  = 1;
   %end;

  data _null_;
    attrib returnCode length=8;
    attrib message    length=$200;
    declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/UpdateUserCommand", "%bquote(&sdduserid)", "%bquote(&sddpassword)");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/DefaultResult");
    cmd.callVoidMethod("execute", results); 
    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
    if (returnCode=0) then do;
	%if %eval(&_infoVerbose_) eq 1 %then %do;
      put;
      put "NOTE: SAS Drug Development Macro: sasdrugdev_updateuser 3.5";
      put "NOTE: SAS Drug Development Macro: * Return Code: " returnCode;
      put "NOTE: SAS Drug Development Macro: * " message;
      put;
	  %end;
    end;
    else do;
	%if %eval(&_errorVerbose_) eq 1 %then %do;
      put;
      put "ERROR: SAS Drug Development Macro: sasdrugdev_updateuser 3.5";
      put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
      put "ERROR: SAS Drug Development Macro: * " message;
      put;
	  %end;
    end;
    call symputx("_sddRC_", returnCode);
    call symputx("_sddMsg_", message);
  run;
%mend sasdrugdev_updateuser;
